#include <iostream>

using namespace std;


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n, q;
    cin >> n >> q;
    long long a[n+1],r[q+1];
    bool t=true;
    for(long long i=1;i<=n;i++){
        cin >> a[i];
        if(a[i]>1){
            t=false;
        }

    }
    
    if(t==true){
        long long nule[n+1],br=0;
        for(long long i=1;i<=n;i++){
            if(a[i]==0){
                nule[br]=i;
                br++;
            }
        }
        
        for(long long i=1;i<=q;i++){
        long long l, d;
        cin >> l >> d;
        long long il=0, id=0;
        long long levo=1, desno=n, mid=(levo+desno)/2;
        while(d-l>1){
            if(l==nule[mid]){
                il=-1;
            }
            if(l<nule[mid]){
                desno=mid-1;
                mid=(levo+desno)/2;
            }
            if(l>nule[mid]){
                levo=mid+1;
                mid=(levo+desno)/2;
            }
        }
        if(il==0){
            il=levo;
        }
        
        levo=1, desno=n, mid=(levo+desno)/2;
        while(d-l>1){
            if(l==nule[mid]){
                id=-2;
            }
            if(l<nule[mid]){
                desno=mid-1;
                mid=(levo+desno)/2;
            }
            if(l>nule[mid]){
                levo=mid+1;
                mid=(levo+desno)/2;
            }
        }
        if(id==0){
            id=levo;
        }
        
        if(il==id){
            r[i]=1;
        }else{
            r[i]=0;
        }
        }
    }else{
    
    for(long long i=1;i<=q;i++){
        long long l, d;
        cin >> l >> d;
        r[i]=a[l];
        for(long long j=l+1;j<=d;j++){
            r[i]=r[i] & a[j];
        }
    }
    
    }
    for(long long i=1;i<=q;i++){
        cout << r[i] << endl;
    }
    return 0;
}